﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="MeasureMapTool.aspx.cs"
    Inherits="CSSamples.MeasureMapTool" %>

<%@ Register Assembly="WebEdition" Namespace="ThinkGeo.MapSuite.WebEdition" TagPrefix="cc1" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
    <link href="~/theme/default/samplepic/style.css" rel="stylesheet" type="text/css" />
    <title>Measure Map Tool</title>

    <script language="javascript" type="text/javascript">
        var OnMapCreating = function(map) {
            mapParser.prototype.initMeasureControls = function() {
                var pathMeasureOption = { id: 'PathMeasure', persist: true };
                var polygonMeasureOption = { id: 'PolygonMeasure', persist: true };
                var units = this.map.getUnits();
                var geodesic = this.json.controls.Measure.geodesic
                OpenLayers.Util.extend(pathMeasureOption, { geodesic: geodesic });
                OpenLayers.Util.extend(polygonMeasureOption, { geodesic: geodesic });
                var displaySystem = this.json.controls.Measure.displaySystem;
                if (displaySystem != 'metric') {
                    OpenLayers.Util.extend(pathMeasureOption, { displaySystem: displaySystem });
                    OpenLayers.Util.extend(polygonMeasureOption, { displaySystem: displaySystem });
                }
                if (typeof getDefaultMeasureStyleMap == 'function') {
                    var styleMap = getDefaultMeasureStyleMap();
                    if (styleMap != null) {
                        OpenLayers.Util.extend(pathMeasureOption, { handlerOptions: { layerOptions: { styleMap: styleMap}} });
                        OpenLayers.Util.extend(polygonMeasureOption, { handlerOptions: { layerOptions: { styleMap: styleMap}} });
                    }
                }
                this.measureControls = {
                    PathMeasure: new OpenLayers.Control.Measure(OpenLayers.Handler.Path, pathMeasureOption),
                    PolygonMeasure: new OpenLayers.Control.Measure(OpenLayers.Handler.Polygon, polygonMeasureOption)
                };
                for (var key in this.measureControls) {
                    var control = this.measureControls[key];
                    this.map.addControl(control);
                    control.events.on({
                        // Todo: Raised after all lines are drawn.
                        "measure": function(event) {
                            var centroid = event.geometry.getCentroid();
                            var popup = new OpenLayers.Popup(map.popups.length, new OpenLayers.LonLat(centroid.x, centroid.y), new OpenLayers.Size(100, 20),
                                           event.geometry.getLength(), true);

                            map.addPopup(popup);
                        },
                        // Todo: Raised after a new point is added
                        "measurepartial": function(event) {
                            var ves = event.geometry.getVertices();
                            var lineSegment = new OpenLayers.Geometry.LineString();
                            var end = ves[ves.length - 1];
                            var end1 = ves[ves.length - 2];
                            lineSegment.addComponent(end);
                            if (end.x == end1.x && end.y == end1.y) {
                                lineSegment.addComponent(ves[ves.length - 3]);
                            } else {
                                lineSegment.addComponent(ves[ves.length - 2]);
                            }
                            var centroid = lineSegment.getCentroid();   // Get the center point to show distance information
                            if (lineSegment.getLength() != 0) {
                                var popup = new OpenLayers.Popup(map.popups.length, new OpenLayers.LonLat(centroid.x, centroid.y), new OpenLayers.Size(100, 20),
                                   lineSegment.getLength(), true);

                                map.addPopup(popup);
                            }
                        },
                        scope: control
                    });
                }
            }
        }
    </script>

</head>
<body>
    <form id="form1" runat="server">
    <asp:ScriptManager ID="ScriptManager1" runat="server">
    </asp:ScriptManager>
    <cc1:Map ID="Map1" runat="server" Width="100%" Height="100%">
    </cc1:Map>
    <Description:DescriptionPanel ID="DescPanel" runat="server">
        This sample demonstrates how to use MeasureMapTool to measure path and polygon on
        the map.
        <br />
        <br />
        Try to click buttons below to measure path or area on the client.
        <br />
        <asp:ImageButton ID="buttonNormal" runat="server" ToolTip="Normal Mode" ImageUrl="~/theme/default/samplepic/Cursor.png"
            OnClientClick="Map1.SetMeasureMode('Normal');return false;" />
        <asp:ImageButton ID="buttonDrawLine" runat="server" ToolTip="Draw Line" ImageUrl="~/theme/default/samplepic/line28.png"
            OnClientClick="Map1.SetMeasureMode('PathMeasure');return false;" />
        <asp:ImageButton ID="buttonDrawPolygon" runat="server" ToolTip="Draw Polygon" ImageUrl="~/theme/default/samplepic/polygon28.png"
            OnClientClick="Map1.SetMeasureMode('PolygonMeasure');return false;" />
    </Description:DescriptionPanel>
    </form>
</body>
</html>
